import 'package:logging/logging.dart';

import 'package:pshared/api/requests/payment/quote.dart';
import 'package:pshared/api/requests/payment/quotes.dart';
import 'package:pshared/api/responses/payment/quotation.dart';
import 'package:pshared/api/responses/payment/quotes.dart';
import 'package:pshared/data/mapper/payment/quote.dart';
import 'package:pshared/data/mapper/payment/quote/quotes.dart';
import 'package:pshared/models/payment/quote/quote.dart';
import 'package:pshared/models/payment/quote/quotes.dart';
import 'package:pshared/service/authorization/service.dart';
import 'package:pshared/service/services.dart';


class QuotationService {
  static final _logger = Logger('service.payment.quotation');
  static const String _objectType = Services.payments;

  static Future<PaymentQuote> getQuotation(
    String organizationRef,
    QuotePaymentRequest request,
  ) async {
    _logger.fine('Quoting payment for organization $organizationRef');
    final response = await AuthorizationService.getPOSTResponse(
      _objectType,
      '/quote/$organizationRef',
      request.toJson(),
    );
    final parsed = PaymentQuoteResponse.fromJson(response);
    return parsed.quote.toDomain(idempotencyKey: parsed.idempotencyKey);
  }

  static Future<PaymentQuotes> getMultiQuotation(
    String organizationRef,
    QuotePaymentsRequest request,
  ) async {
    _logger.fine('Quoting payments for organization $organizationRef');
    final response = await AuthorizationService.getPOSTResponse(
      _objectType,
      '/multiquote/$organizationRef',
      request.toJson(),
    );
    final parsed = PaymentQuotesResponse.fromJson(response);
    return parsed.quote.toDomain();
  }
}
